=== debian/watch ===
version=4
https://github.com/FLIF-hub/FLIF/tags (?:.*/)?v?(\d[\d\.]*)\.tar\.gz
