## flif 0.4

=== debian/changelog ===
flif (0.4-0ddebs1~ubuntu24.04) noble; urgency=medium

  * New upstream release.

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Sun, 23 Nov 2025 23:26:59 +0100

flif (0.3-7ddebs5) unstable; urgency=medium

  * Updated to standards-version 4.6.2
  * use debhelper compatibility v13

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Mon, 11 Mar 2024 01:06:46 +0100

flif (0.3-7ddebs4) unstable; urgency=medium

  * use xz compression until debian 13 is released

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Sat, 22 Apr 2023 16:44:32 +0200

flif (0.3-7ddebs3) unstable; urgency=medium

  * update to standards-version 4.6.0.1
  * make use of debhelper-compat (= 12) dependency, and remove
    debian/compat file

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Tue, 05 Apr 2022 11:07:27 +0200

flif (0.3-7ddebs2) unstable; urgency=medium

  * updated to standards-version 4.5.0

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Sun, 19 Apr 2020 11:59:43 +0200

flif (0.3-7ddebs1) unstable; urgency=medium

  * Version for my repository.

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Sun, 09 Dec 2018 01:46:13 +0100

flif (0.3-7) experimental; urgency=medium

  * Build-Conflict on graphicsmagick-imagemagick-compat (#897621)
  * d/gbp.conf: upstream-branch = upstream/latest (DEP14)
  * d/gbp.conf: pristine-tar(-commit) = True

 -- Paride Legovini <pl@ninthfloor.org>  Wed, 11 Jul 2018 12:00:13 +0000

flif (0.3-6) experimental; urgency=medium

  * Release to experimental, as the package will be pulled from unstable.
    This is due to open CVEs. Further details are given in the NEWS file.
  * Build-Conflict on graphicsmagick-imagemagick-compat (#897621).
  * Bump Standards-Version to 4.1.5 (no changes needed).

 -- Paride Legovini <pl@ninthfloor.org>  Tue, 10 Jul 2018 11:50:56 +0000
