=== debian/control ===
--- 
+++ 
@@ -1,14 +1,22 @@
 Source: flif
-Section: graphics
+Section: utils
 Priority: optional
 Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: Paride Legovini <pl@ninthfloor.org>
-Build-Depends: debhelper (>=11~), dh-exec (>=0.3), bash-completion,
- libpng-dev, libsdl2-dev, libimage-exiftool-perl, imagemagick
-Standards-Version: 4.1.4
+Build-Depends:
+ debhelper-compat (= 13),
+ dh-exec (>=0.3),
+ bash-completion,
+ libpng-dev,
+ libsdl2-dev,
+ libimage-exiftool-perl,
+ imagemagick
+Build-Conflicts: graphicsmagick-imagemagick-compat
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/flif.git
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/flif
-Homepage: http://flif.info/
+Homepage: https://flif.info/
+Rules-Requires-Root: no
 
 Package: libflif0
 Section: libs
