=== debian/watch ===
version=4
opts="compression=xz,repack" \
  https://github.com/FLIF-hub/FLIF/tags (?:.*/)?v?(\d[\d\.]*)\.tar\.gz \
debian uupdate
